// Deathstrike CC
// DeathKnight Release
// by Wulf
//
// Credits to fiftypence from the Honorbuddy forums his DoctrineRet CC without which this CC would not be possible.
//
// TODO:
// better ui
// working UI
// racials
// fix the damned functions for precombatbuffs and buffs

using System;
using System.Drawing;
using System.Collections.Generic;
using System.Threading;

using System.Linq;
using System.Diagnostics;
using System.IO;

using Styx;
using Styx.Combat.CombatRoutine;
using Styx.Helpers;
using Styx.Logic;
using Styx.Logic.Combat;
using Styx.Logic.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace Deathstrike
{
    partial class DeathKnight : CombatRoutine
    {
        public static Version curVersion = new Version(2, 5);

        public static DeathKnight Instance = new DeathKnight();

        public static LocalPlayer Me { get { return ObjectManager.Me; } }
            
        public override string Name { get { return "Deathstrike v" + curVersion; } }
        public override WoWClass Class { get { return WoWClass.DeathKnight; } }

        public static HashSet<string> Glyphs { get; private set; }       

        public override void Initialize()
        {
            DeathstrikeSettings.Instance.Load();

            //LoadGlyphs();

            Logging.Write(Color.Orange, "");
            Logging.Write(Color.Orange, Name + " has been loaded.");
            Logging.Write(Color.Orange, "");
            Logging.Write(Color.Orange, "Greetings {0}!", Me.Name);
            Logging.Write(Color.Orange, "You are level {0}", Me.Level);
            if (!logDebug) 
            {
                Logging.Write(Color.Red, "Logging is Disabled by default ");
                Logging.Write(Color.Red, "Open class config and tick Enable Logging ");
                Logging.Write(Color.Red, "If you would like to see what the CC is doing. ");
            }
            
            Logging.Write(Color.Orange, "");
        }

        public override void Pull()
        {
            if (Presence == 1 && Me.CurrentTarget != null && !Me.CurrentTarget.Dead) //Blood Presence form single target
            {
                if (UseFaceTarget) WoWMovement.Face();
                if (UseMovement && Me.CurrentTarget.Distance2D > 4.5)
                {
                        Navigator.MoveTo(Me.CurrentTarget.Location);
                } 
                // Death Coil Pull - 40 Runic Power / 30 - 40 yd range
                if (SpellManager.CanCast("Death Coil") && Me.CurrentRunicPower < PowerCost("Death Coil") && IsDistanceLessThan(MaxDistance("Death Coil")))
                {
                    SpellManager.Cast("Death Coil");
                    Logging.Write(Color.LightBlue, "[" + Me.CurrentRunicPower + " RP]" + "Pulling with Death Coil");
                }
                // Death Grip Pull - Instant / 30 yd range / 35 sec cooldown (Death Grip's taunt cannot miss, but mobs can be immune to the grip part of the spell. )
                else if (SpellManager.CanCast("Death Grip") && IsDistanceLessThan(MaxDistance("Death Grip")))
                {
                    SpellManager.Cast("Death Grip");
                    Logging.Write(Color.LightBlue, "[" + Me.CurrentRunicPower + " RP]" + "Pulling with Death Grip");
                }
                //Icy Touch Pull - 1 Frost / 20 yd range
                else if (SpellManager.CanCast("Icy Touch") && IsDistanceLessThan(MaxDistance("Icy Touch")))
                {
                    SpellManager.Cast("Icy Touch");
                    Logging.Write(Color.LightBlue, "[" + Me.CurrentRunicPower + " RP]" + "Pulling with Icy Touch");
                }               
            }
            if (Presence == 0 && !Me.IsInInstance && !Me.IsInRaid && !Me.IsInParty && Me.CurrentTarget != null && !Me.CurrentTarget.Dead) //Frost Presence form single target
            {
                if (UseFaceTarget) WoWMovement.Face();
                if (UseMovement && Me.CurrentTarget.Distance2D > 4.5)
                {
                        Navigator.MoveTo(Me.CurrentTarget.Location);
                } 
                // Death Coil Pull - 40 Runic Power / 30 - 40 yd range
                if (SpellManager.CanCast("Death Coil") && Me.CurrentRunicPower < PowerCost("Death Coil") && IsDistanceLessThan(MaxDistance("Death Coil")))
                {
                    SpellManager.Cast("Death Coil");
                    Logging.Write(Color.LightBlue, "[" + Me.CurrentRunicPower + " RP]" + "Pulling with Death Coil");
                }
                // Death Grip Pull - Instant / 30 yd range / 35 sec cooldown (Death Grip's taunt cannot miss, but mobs can be immune to the grip part of the spell. )
                else if (SpellManager.CanCast("Death Grip") && IsDistanceLessThan(MaxDistance("Death Grip")))
                {
                    SpellManager.Cast("Death Grip");
                    Logging.Write(Color.LightBlue, "[" + Me.CurrentRunicPower + " RP]" + "Pulling with Death Grip");
                }
                //Icy Touch Pull - 1 Frost / 20 yd range
                else if (SpellManager.CanCast("Icy Touch") && IsDistanceLessThan(MaxDistance("Icy Touch")))
                {
                    SpellManager.Cast("Icy Touch");
                    Logging.Write(Color.LightBlue, "[" + Me.CurrentRunicPower + " RP]" + "Pulling with Icy Touch");
                }
            }
           
            AutoAttack();
        }

        public override void Combat()
        {
            if (Presence == 1 && UseTaunt) //Blood Presence form single target
            {
                Taunt();
            }
                      
            if ((UseNeverDismount && !Me.Mounted) || !UseNeverDismount)
            {
                if (Me.CurrentTarget != null && !Me.CurrentTarget.Dead)
                {
                    if (UseFaceTarget) WoWMovement.Face();

                    if (UseMovement && Me.CurrentTarget.Distance2D > 4.5)
                    {
                        Navigator.MoveTo(Me.CurrentTarget.Location);
                    }

                    else
                    {
                        if (EnemyUnits.Count < 3 || IsTargetRaidBoss() || (!Me.IsInRaid && IsTargetDungeonBoss(Me.CurrentTarget)))
                        {
                            if (Presence == 1) //Blood Presence form single target
                            {
                                Cooldowns();
                                TrinketUsage();                           
                                Interrupt();
                                SingleTargetRotation();
                                //AoERotation();
                            }
                            if (Presence == 0) //Unholy Presence - Frost spec uses Unholy presence single target
                            {
                                ReduceThreat();
                                Cooldowns();
                                TrinketUsage();                           
                                Interrupt();
                                //AoERotation();
                                SingleTargetRotation();
                            }
                            
                        }
                        else
                        {
                            if (Presence == 1) //Blood Presence AoE target
                            {
                                Cooldowns();
                                TrinketUsage();
                                Interrupt();
                                AoERotation();
                            }
                            if (Presence == 0) //Unholy Presence Frost spec uses Unholy AoE target
                            {
                                 ReduceThreat();
                                 Cooldowns();
                                 TrinketUsage();
                                 Interrupt();
                                 AoERotation();
                              
                            }
                        }
                    }
                }
                else if (UseTarget != 0)
                {
                    GetTarget();
                }
            }
        }

         public override bool NeedRest
        {
            get
            {
                if ((Me.HealthPercent <= 50 || Me.ManaPercent <= 50) && !Me.IsSwimming)
                {
                    return true;
                }
                else
                    return false;
            }
        }

        public override void Rest()
        {
            if ((Me.HealthPercent <= 50 || Me.ManaPercent <= 50) && !Me.IsSwimming)
            {
                Styx.Logic.Common.Rest.Feed();
            }
        }

        public override bool NeedPreCombatBuffs
        {
            get
            {
                // all precombat buffs will simply go here
                // and the function will return false
                // bit hackish, but it seems so pointless to check for all buffs here
                // then a second time in PreCombatBuff()
                // will fix at a later date
                if ((UseNeverDismount && !Me.Mounted) || !UseNeverDismount)
                {
                    // all buffs answer to the mighty global cooldown
                    if (!SpellManager.GlobalCooldown && !Me.IsGhost)
                    {
                        if (!Me.Auras.ContainsKey("Horn of Winter") && !Me.Auras.ContainsKey("Battle Shout") && !Me.Auras.ContainsKey("Roar of Courage") && !Me.Auras.ContainsKey("Strength of Earth Totem") && SpellManager.CanCast("Horn of Winter") && PlayerBuffTimeLeft("Horn of Winter") <= 60)
                        {
                            Logging.Write(Color.Lime, "=== [" + Me.CurrentHealth + " Hp] Horn of Winter");
                            
                            SpellManager.Cast("Horn of Winter");
                            return false;
                        }
                        if (Presence == 1) //Blood Presence form single target
                        {
                            if (!Me.HasAura("Bone Shield"))
                            {
                                if (SpellManager.CanCast("Blood Tap") && !IsOnCooldown("Bone Shield"))
                                {
                                    SpellManager.Cast("Blood Tap");
                                    Logging.Write(Color.Lime, "=== [" + Me.CurrentHealth + " Hp] Blood Tap for Bone Shield");

                                    SpellManager.Cast("Bone Shield");
                                    Logging.Write(Color.Lime, "=== [" + Me.CurrentHealth + " Hp] Bone Shield Activated");
                                    return false;
                                }
                                if ((Me.UnholyRuneCount > 0 || Me.DeathRuneCount > 0) && !IsOnCooldown("Bone Shield"))
                                {
                                    SpellManager.Cast("Bone Shield");
                                    Logging.Write(Color.Lime, "=== [" + Me.CurrentHealth + " Hp] Bone Shield Activated");
                                    return false;

                                }

                            }
                        }
                        if (Presence == 0) //Unholy Presence - Frost spec uses Unholy presence single target
                        {
                            return false;
                        }
                    }
                    return false;
                }
                return false;
            }
        }

        public override void PreCombatBuff()
        {
            
        }

        public override bool NeedCombatBuffs
        {
            // as with NeedPreCombatBuffs()
            // everything will be done in this function
            // and it will return false
            // will be fixed later

            get
            {
                // instant Spells - get em while there hot!
                if ((UseNeverDismount && !Me.Mounted) || !UseNeverDismount)
                {

                    if (damageReduction() == false)
                    {
                        return false;
                    }                    

                }
                return false; //I am mounted
            }

        }

        public override void CombatBuff()
        {

        }

        public override bool NeedHeal
        {
            get
            {
                return false;
            }
        }

        public override void Heal()
        {
        }

        public override void Pulse()
        {
            if (Me.IsInRaid && CurrentSettings != "Raid")
            {
                InitialiseSettings();

                Logging.Write("");
                Logging.Write(Color.Orange, "We are using raid settings");
                Logging.Write(Color.Orange, "Current Settings:");
                Logging.Write(Color.Red, " - Logging Enabled ?: " + logDebug);
                Logging.Write(Color.Orange, " - Presence (0=Unholy/1=Blood): " + Presence);
                Logging.Write(Color.Orange, " - Force Presence: " + ForcePresence);
                Logging.Write(Color.Orange, " - IceboundFortitude < (%): " + IceboundFortitude);
                Logging.Write(Color.Orange, " - VampiricBlood < (%): " + VampiricBlood);
                Logging.Write(Color.Orange, " - RuneTap < (%): " + RuneTap);
                Logging.Write(Color.Orange, " - DeathPact < (%): " + DeathPact);
                Logging.Write(Color.Orange, " - LichborneDC < (%): " + LichborneDC);
                Logging.Write(Color.Orange, " - Empower Rune Weapon ?: " + UseERW);
                Logging.Write(Color.Orange, " - Dancing Rune Weapon ?: " + UseDRW);
                Logging.Write(Color.Orange, " - Use Taunt: " + UseTaunt);
                Logging.Write(Color.Orange, " - Use Movement: " + UseMovement);
                Logging.Write(Color.Orange, " - Face Target: " + UseFaceTarget);
                Logging.Write(Color.Orange, " - Auto Target: " + UseTarget);
                Logging.Write(Color.Orange, " - Cooldowns: " + UseCooldowns);
                Logging.Write(Color.Orange, " - Use Interupts: " + UseInterrupt);
                Logging.Write(Color.Orange, " - Use Trinket 1: " + UseTrinket1);
                Logging.Write(Color.Orange, " - Use Trinket 2: " + UseTrinket2);
                Logging.Write(Color.Orange, " - Never dismount: " + UseNeverDismount);
            }
            else if (!Me.IsInRaid && CurrentSettings != "Party")
            {
                InitialiseSettings();
                
                CurrentSettings = "Party";

                Logging.Write("");
                Logging.Write(Color.Orange, "We are using party settings");
                Logging.Write(Color.Orange, "Current Settings:");
                Logging.Write(Color.Red, " - Logging Enabled ?: " + logDebug);
                Logging.Write(Color.Orange, " - Presence (0=Unholy/1=Blood): " + Presence);
                Logging.Write(Color.Orange, " - Force Presence: " + ForcePresence);
                Logging.Write(Color.Orange, " - IceboundFortitude < (%): " + IceboundFortitude);
                Logging.Write(Color.Orange, " - VampiricBlood < (%): " + VampiricBlood);
                Logging.Write(Color.Orange, " - RuneTap < (%): " + RuneTap);
                Logging.Write(Color.Orange, " - DeathPact < (%): " + DeathPact);
                Logging.Write(Color.Orange, " - LichborneDC < (%): " + LichborneDC);
                Logging.Write(Color.Orange, " - Empower Rune Weapon ?: " + UseERW);
                Logging.Write(Color.Orange, " - Dancing Rune Weapon ?: " + UseDRW);
                Logging.Write(Color.Orange, " - Use Taunt: " + UseTaunt);
                Logging.Write(Color.Orange, " - Use Movement: " + UseMovement);
                Logging.Write(Color.Orange, " - Face Target: " + UseFaceTarget);
                Logging.Write(Color.Orange, " - Auto Target: " + UseTarget);
                Logging.Write(Color.Orange, " - Cooldowns: " + UseCooldowns);
                Logging.Write(Color.Orange, " - Use Interupts: " + UseInterrupt);
                Logging.Write(Color.Orange, " - Use Trinket 1: " + UseTrinket1);
                Logging.Write(Color.Orange, " - Use Trinket 2: " + UseTrinket2);
                Logging.Write(Color.Orange, " - Never dismount: " + UseNeverDismount);
            }


        }

        public override bool WantButton { get { return true; } }

        public override void OnButtonPress()
        {
            Deathstrike.DeathstrikeConfig conf = new Deathstrike.DeathstrikeConfig();
            conf.ShowDialog();
        }
    }
}
















