﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Styx.Helpers;

namespace Deathstrike
{
    public partial class DeathstrikeConfig : Form
    {
        public DeathstrikeConfig()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            if (DeathstrikeSettings.Instance.Setting_Presence == 0)
            {
                radioButton1.Select();
            }
            else if (DeathstrikeSettings.Instance.Setting_Presence == 1)
            {
                radioButton2.Select();
            }

            checkBox1.Checked = DeathstrikeSettings.Instance.Setting_Party_UseMovement;
            checkBox2.Checked = DeathstrikeSettings.Instance.Setting_Party_UseFaceTarget;
            checkBox3.Checked = DeathstrikeSettings.Instance.Setting_UseERW;
            checkBox9.Checked = DeathstrikeSettings.Instance.Setting_UseDRW;
            checkBox10.Checked = DeathstrikeSettings.Instance.Setting_Logging;

            checkBox5.Checked = DeathstrikeSettings.Instance.Setting_Party_UseTaunt;
            checkBox6.Checked = DeathstrikeSettings.Instance.Setting_Party_UseInterrupt;
            checkBox7.Checked = DeathstrikeSettings.Instance.Setting_Raid_UseTaunt;
            checkBox4.Checked = DeathstrikeSettings.Instance.Setting_Raid_UseInterrupt;
            checkBox8.Checked = DeathstrikeSettings.Instance.Setting_ForcePresence;

            trackBar1.Value = DeathstrikeSettings.Instance.Setting_IceboundFortitude;
            trackBar2.Value = DeathstrikeSettings.Instance.Setting_VampiricBlood;
            trackBar3.Value = DeathstrikeSettings.Instance.Setting_RuneTap;
            trackBar4.Value = DeathstrikeSettings.Instance.Setting_DeathPact;
            trackBar5.Value = DeathstrikeSettings.Instance.Setting_LichborneDC;

            string currentVersion = Convert.ToString(DeathKnight.curVersion);

            label12.Text = currentVersion;
            

            string trackerbar = Convert.ToString(trackBar1.Value);
            label1.Text = trackerbar;

            string trackerbar2 = Convert.ToString(trackBar2.Value);
            label6.Text = trackerbar2;

            string trackerbar3 = Convert.ToString(trackBar3.Value);
            label7.Text = trackerbar3;

            string trackerbar4 = Convert.ToString(trackBar4.Value);
            label9.Text = trackerbar4;

            string trackerbar5 = Convert.ToString(trackBar5.Value);
            label10.Text = trackerbar5;


            if (DeathstrikeSettings.Instance.Setting_Party_UseTrinket1 == 0)
            {
                radioButton3.Select();
            }
            else if (DeathstrikeSettings.Instance.Setting_Party_UseTrinket1 == 1)
            {
                radioButton4.Select();
            }
            else if (DeathstrikeSettings.Instance.Setting_Party_UseTrinket1 == 2)
            {
                radioButton5.Select();
            }

            if (DeathstrikeSettings.Instance.Setting_Party_UseTrinket2 == 0)
            {
                radioButton6.Select();
            }
            else if (DeathstrikeSettings.Instance.Setting_Party_UseTrinket2 == 1)
            {
                radioButton7.Select();
            }
            else if (DeathstrikeSettings.Instance.Setting_Party_UseTrinket2 == 2)
            {
                radioButton8.Select();
            }

            if (DeathstrikeSettings.Instance.Setting_Raid_UseTrinket1 == 0)
            {
                radioButton9.Select();
            }
            else if (DeathstrikeSettings.Instance.Setting_Raid_UseTrinket1 == 1)
            {
                radioButton10.Select();
            }
            else if (DeathstrikeSettings.Instance.Setting_Raid_UseTrinket1 == 2)
            {
                radioButton11.Select();
            }

            if (DeathstrikeSettings.Instance.Setting_Raid_UseTrinket2 == 0)
            {
                radioButton12.Select();
            }
            else if (DeathstrikeSettings.Instance.Setting_Raid_UseTrinket2 == 1)
            {
                radioButton13.Select();
            }
            else if (DeathstrikeSettings.Instance.Setting_Raid_UseTrinket2 == 2)
            {
                radioButton14.Select();
            }
            
        }
        

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1.Checked)
            {
                DeathstrikeSettings.Instance.Setting_Presence = 0;
            }
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton2.Checked)
            {
                DeathstrikeSettings.Instance.Setting_Presence = 1;
            }
        }

        private void checkBox1_CheckedChanged_1(object sender, EventArgs e)
        {
            DeathstrikeSettings.Instance.Setting_Party_UseMovement = checkBox1.Checked;
        }

        private void checkBox2_CheckedChanged_1(object sender, EventArgs e)
        {
            DeathstrikeSettings.Instance.Setting_Party_UseFaceTarget = checkBox2.Checked;
        }
        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            DeathstrikeSettings.Instance.Setting_UseERW = checkBox3.Checked;
        }

        
        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton3.Checked)
            {
                DeathstrikeSettings.Instance.Setting_Party_UseTrinket1 = 0;
            }
        }

        private void radioButton4_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton4.Checked)
            {
                DeathstrikeSettings.Instance.Setting_Party_UseTrinket1 = 1;
            }
        }

        private void radioButton5_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton5.Checked)
            {
                DeathstrikeSettings.Instance.Setting_Party_UseTrinket1 = 2;
            }
        }

        private void radioButton6_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton6.Checked)
            {
                DeathstrikeSettings.Instance.Setting_Party_UseTrinket2 = 0;
            }
        }

        private void radioButton7_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton7.Checked)
            {
                DeathstrikeSettings.Instance.Setting_Party_UseTrinket2 = 1;
            }
        }

        private void radioButton8_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton8.Checked)
            {
                DeathstrikeSettings.Instance.Setting_Party_UseTrinket2 = 2;
            }
        }

        private void checkBox5_CheckedChanged(object sender, EventArgs e)
        {
            DeathstrikeSettings.Instance.Setting_Party_UseTaunt = checkBox5.Checked;
        }

        private void checkBox6_CheckedChanged(object sender, EventArgs e)
        {
            DeathstrikeSettings.Instance.Setting_Party_UseInterrupt = checkBox6.Checked;
        }

        private void radioButton9_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton9.Checked)
            {
                DeathstrikeSettings.Instance.Setting_Raid_UseTrinket1 = 0;
            }
        }

        private void radioButton10_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton10.Checked)
            {
                DeathstrikeSettings.Instance.Setting_Raid_UseTrinket1 = 1;
            }
        }

        private void radioButton11_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton11.Checked)
            {
                DeathstrikeSettings.Instance.Setting_Raid_UseTrinket1 = 2;
            }
        }

        private void radioButton12_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton12.Checked)
            {
                DeathstrikeSettings.Instance.Setting_Raid_UseTrinket2 = 0;
            }
        }

        private void radioButton13_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton13.Checked)
            {
                DeathstrikeSettings.Instance.Setting_Raid_UseTrinket2 = 1;
            }
        }

        private void radioButton14_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton14.Checked)
            {
                DeathstrikeSettings.Instance.Setting_Raid_UseTrinket2 = 2;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            DeathstrikeSettings.Instance.Save();
            Logging.Write("");
            Logging.Write(Color.Red, "Please restart Honour Buddy for settings to take affect");
            Close();
        }



        private void checkBox4_CheckedChanged(object sender, EventArgs e)
        {
          DeathstrikeSettings.Instance.Setting_Raid_UseInterrupt = checkBox4.Checked;
        }

        private void checkBox7_CheckedChanged(object sender, EventArgs e)
        {
            DeathstrikeSettings.Instance.Setting_Raid_UseTaunt = checkBox7.Checked;
        }

        private void checkBox8_CheckedChanged(object sender, EventArgs e)
        {
            DeathstrikeSettings.Instance.Setting_ForcePresence = checkBox8.Checked;
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            DeathstrikeSettings.Instance.Setting_IceboundFortitude = trackBar1.Value;

            string trackerbar = Convert.ToString(trackBar1.Value);
            label1.Text = trackerbar;

            if (trackerbar == "100")
            {
                MessageBox.Show("You have reached the maximum");
            }
        }

        private void trackBar2_Scroll(object sender, EventArgs e)
        {
            DeathstrikeSettings.Instance.Setting_VampiricBlood = trackBar2.Value;

            string trackerbar = Convert.ToString(trackBar2.Value);
            label6.Text = trackerbar;

            if (trackerbar == "100")
            {
                MessageBox.Show("You have reached the maximum");
            }
        }

        private void trackBar3_Scroll(object sender, EventArgs e)
        {
            DeathstrikeSettings.Instance.Setting_RuneTap = trackBar3.Value;

            string trackerbar = Convert.ToString(trackBar3.Value);
            label7.Text = trackerbar;

            if (trackerbar == "100")
            {
                MessageBox.Show("You have reached the maximum");
            }
        }

        private void trackBar4_Scroll(object sender, EventArgs e)
        {
            DeathstrikeSettings.Instance.Setting_DeathPact = trackBar4.Value;

            string trackerbar = Convert.ToString(trackBar4.Value);
            label9.Text = trackerbar;

            if (trackerbar == "100")
            {
                MessageBox.Show("You have reached the maximum");
            }
        }

        private void trackBar5_Scroll(object sender, EventArgs e)
        {
            DeathstrikeSettings.Instance.Setting_LichborneDC = trackBar5.Value;

            string trackerbar = Convert.ToString(trackBar5.Value);
            label10.Text = trackerbar;

            if (trackerbar == "100")
            {
                MessageBox.Show("You have reached the maximum");
            }
        }

        private void checkBox9_CheckedChanged(object sender, EventArgs e)
        {
            DeathstrikeSettings.Instance.Setting_UseDRW = checkBox9.Checked;
        }

        private void checkBox10_CheckedChanged(object sender, EventArgs e)
        {
            DeathstrikeSettings.Instance.Setting_Logging = checkBox10.Checked;
        }

    }
}
